searchNodes=[{"doc":"Core module for EctoCellar. Handles versions table created by mix ecto_cellar.gen . You can use this module to store in the cellar and restore the version. Options repo: You can select a repo other than the one specified in Config.","ref":"EctoCellar.html","title":"EctoCellar","type":"module"},{"doc":"Returns all versions of model from the cellar.","ref":"EctoCellar.html#all/2","title":"EctoCellar.all/2","type":"function"},{"doc":"Deletes given changeset and stores the changes at that time in the cellar. options: EctoCellar.options() delete_opts: options for Ecto.Repo.update/2","ref":"EctoCellar.html#delete_store/3","title":"EctoCellar.delete_store/3","type":"function"},{"doc":"Inserts given model（or changeset） and stores the changes at that time in the cellar. options: EctoCellar.options() insert_opts: options for Ecto.Repo.insert/2","ref":"EctoCellar.html#insert_store/3","title":"EctoCellar.insert_store/3","type":"function"},{"doc":"Returns a specific version of model from the cellar.","ref":"EctoCellar.html#one/3","title":"EctoCellar.one/3","type":"function"},{"doc":"Stores the changes at that time in the cellar.","ref":"EctoCellar.html#store/2","title":"EctoCellar.store/2","type":"function"},{"doc":"Like store/2, except that if the record is invalid, raises an exception.","ref":"EctoCellar.html#store!/2","title":"EctoCellar.store!/2","type":"function"},{"doc":"Updates given changeset and stores the changes at that time in the cellar. options: EctoCellar.options() update_opts: options for Ecto.Repo.update/2","ref":"EctoCellar.html#update_store/3","title":"EctoCellar.update_store/3","type":"function"},{"doc":"Inserts or updates given changeset and stores the changes at that time in the cellar. options: EctoCellar.options() insert_or_update_opts: options for Ecto.Repo.insert_or_update/2","ref":"EctoCellar.html#upsert_store/3","title":"EctoCellar.upsert_store/3","type":"function"},{"doc":"","ref":"EctoCellar.html#t:options/0","title":"EctoCellar.options/0","type":"type"},{"doc":"","ref":"Mix.Tasks.EctoCellar.Gen.html","title":"Mix.Tasks.EctoCellar.Gen","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.EctoCellar.Gen.html#run/1","title":"Mix.Tasks.EctoCellar.Gen.run/1","type":"function"},{"doc":"EctoCellar Store changes to your models, for auditing or versioning. Inspired by paper_trail .","ref":"readme.html","title":"README","type":"extras"},{"doc":"This is the user guide. See also, the API reference .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding ecto_cellar to your list of dependencies in mix.exs : def deps do [ { :ecto_cellar , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"1. Configuration. Add ecto_cellar configure to your config.exs. config :ecto_cellar , :default_repo , YourApp.Repo 2. Creates versions table. You can generate migration file for EctoCeller. Let's type mix ecto_cellar.gen . And migrate by mix ecto.migrate . 3. Stores changes to model. Stores after a model is changed or created. These are stored as recoverable versions for the versions table. By Repo.insert + EctoCellar.store/2 . iex&gt; with { :ok , post } &lt;- % Post { title : &quot;title&quot; , views : 0 } |&gt; @repo . insert ( ) , ...&gt; { :ok , _post } &lt;- EctoCellar . store ( post ) do # or store!/2 ...&gt; # do something ...&gt; end or There is also a function that wraps EctoRepo.insert , update , insert_or_update and delete . By EctoCellar.insert_store/3 . （Uses EctoCellar.update_store/3 when updated.） iex&gt; case EctoCellar . insert_store ( post ) do # or update_store/3, upsert_store/3, delete_store/3 ...&gt; { :ok , _post } -&gt; # do_somesing ...&gt; error -&gt; error ...&gt; end 4. Gets versions and can restore it. Uses EctoCellar.all/2 and EctoCellar.one/3 , you can get past changes versions. And use it, you can restore. iex&gt; post = Post . find ( id ) % Post { id : 1 , body : &quot;body3&quot; ... etc } iex&gt; post_versions = EctoCellar . all ( post ) # Can get all versions. [ % Post { id : 1 , body : &quot;body3&quot; ... etc } , % Post { id : 1 , body : &quot;body2&quot; ... etc } , % Post { id : 1 , body : &quot;body1&quot; ... etc } ] iex&gt; version_1_inserted_at = ~N[2022/12/12 12:00:12] iex&gt; post_version1 = EctoCellar . one ( post , version_1_inserted_at ) % Post { id : 1 , body : &quot;body1&quot; , inserted_at : ~N[2022/12/12 12:00:12] ... etc } iex&gt; post_version1 iex&gt; |&gt; Post . changeset ( [ ] ) iex&gt; |&gt; Repo . update ( ) # Restored！！！ Options The last argument of each function accepts the following options. repo: You can select a repo other than the one specified in Config.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"You can test locally in these steps. make setup mix test","ref":"readme.html#for-contributers","title":"README - For contributers","type":"extras"},{"doc":"Feel free to open an issues or a PR to contribute to the project.","ref":"readme.html#bugs-and-feature-requests","title":"README - Bugs and Feature requests","type":"extras"}]